/*
 *  Copyright (C) 2008 Florent Bedoiseau (electronique.fb@free.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "ZXFiles.h"
using namespace std;

ZXFiles::ZXFiles (const string & rep) : _repbase (rep) {
  browseFiles ();
}

ZXFiles::~ZXFiles() {
}

bool ZXFiles::browseFiles () {
  DIR_ITER* dir = diropen(_repbase.c_str());
  if (dir == NULL) {
	return false;
  }

  struct stat st;
  char filename[256];
  while (dirnext(dir, filename, &st) == 0) {
	// st.st_mode & S_IFDIR indicates a directory
	if (!(st.st_mode & S_IFDIR)) {
	  string f = filename;
	  if (f.size()>3) {
		string ext = f.substr(f.size() - 3, 3);
		if (ext == "sna") {
		  _sna.push_back(f);
		}
		else if (ext == "gif") {
		  _gif.push_back(f);
		}
	  }
	}
  }
  dirclose (dir);
  return true;
}

bool ZXFiles::getGifFile (const string & sna, string &giffile) {
  string gif =  sna.substr(0, sna.size() - 3);
  gif = gif + "gif";
  list<string>::iterator it;
  for (it = _gif.begin(); it != _gif.end(); it++) {
	if (*it == gif) { 
	  giffile = _repbase + *it;
	  return true;
	}
  }
  giffile="";

  return false;
}
