/*
 *  Copyright (C) 2008 Florent Bedoiseau (electronique.fb@free.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef ZXSEQUENCER_H
#define ZXSEQUENCER_H
#include <PA9.h>
#include <deque>
#include <string>

class ZXSequencer {
 public:
  ZXSequencer ();
  ~ZXSequencer ();
  void setSequence (const std::deque<std::string> & sequence);
  char getKey ();

 private:
  std::deque<std::string> _sequence;
  bool _empty;
  u16 _wait;
  std::string _token; 
  void pop ();
  
};

#endif
